# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/Config/000_config.ipynb.

# %% auto 0
__all__ = ['logger', 'config_path_env', 'config_path_local', 'config_path_pkg', 'DB_HOSTS']

# %% ../../nbs/Config/000_config.ipynb 4
import logging
import os
import sys
from pathlib import Path

import toml

# Config.
logging.basicConfig(
    level=logging.INFO, format="%(asctime)s - %(message)s", datefmt="%Y-%m-%d %H:%M:%S"
)

logger = logging.getLogger(__name__)

# Read local `config.toml` file.
config_path_env = os.getenv("BETTING_ENV_CONFIG")
config_path_local = Path("/secrets/config.toml")
config_path_pkg = Path("../../config.toml")

if not config_path_env is None and Path(config_path_env).exists():
    CONFIG = toml.load(config_path_env)
elif config_path_local.exists():
    CONFIG = toml.load(config_path_local)
elif config_path_pkg.exists():
    CONFIG = toml.load(config_path_pkg)
else:
    logger.error(
        "No config file found under `BETTING_ENV_CONFIG`, pkg root or in `/secrets/config.toml`!"
    )
    sys.exit()

# Defined database hosts.
DB_HOSTS = set([db for db in CONFIG["databases"]])
